/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/core/TransformRotateModel.as
 * org.apache.flex.core.TransformRotateModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.core.TransformRotateModel');

goog.require('org.apache.flex.core.TransformModel');
goog.require('org.apache.flex.geom.Matrix');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.core.TransformModel}
 */
org.apache.flex.core.TransformRotateModel = function() {
  org.apache.flex.core.TransformRotateModel.base(this, 'constructor');
};
goog.inherits(org.apache.flex.core.TransformRotateModel, org.apache.flex.core.TransformModel);


/**
 * @private
 * @type {number}
 */
org.apache.flex.core.TransformRotateModel.prototype._angle;


Object.defineProperties(org.apache.flex.core.TransformRotateModel.prototype, /** @lends {org.apache.flex.core.TransformRotateModel.prototype} */ {
/** @export */
angle: {
get: /** @this {org.apache.flex.core.TransformRotateModel} */ function() {
  return this._angle;
},
set: /** @this {org.apache.flex.core.TransformRotateModel} */ function(value) {
  this._angle = value;
  var /** @type {number} */ radians = value * Math.PI / 180;
  this.matrix = new org.apache.flex.geom.Matrix(Math.cos(radians), Math.sin(radians), -Math.sin(radians), Math.cos(radians));
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.core.TransformRotateModel.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'TransformRotateModel', qName: 'org.apache.flex.core.TransformRotateModel'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.core.TransformRotateModel', org.apache.flex.core.TransformRotateModel);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.core.TransformRotateModel.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'angle': { type: 'Number', declaredBy: 'org.apache.flex.core.TransformRotateModel'}
      };
    },
    methods: function () {
      return {
        'TransformRotateModel': { type: '', declaredBy: 'org.apache.flex.core.TransformRotateModel'}
      };
    }
  };
};