/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/events/ProgressEvent.as
 * org.apache.flex.events.ProgressEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.events.ProgressEvent');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.events.Event}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {number=} current
 * @param {number=} total
 */
org.apache.flex.events.ProgressEvent = function(type, bubbles, cancelable, current, total) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  current = typeof current !== 'undefined' ? current : NaN;
  total = typeof total !== 'undefined' ? total : NaN;
  org.apache.flex.events.ProgressEvent.base(this, 'constructor', type, bubbles, cancelable);
  this.current = current;
  this.total = total;
};
goog.inherits(org.apache.flex.events.ProgressEvent, org.apache.flex.events.Event);


/**
 * @export
 * @type {number}
 */
org.apache.flex.events.ProgressEvent.prototype.current;


/**
 * @export
 * @type {number}
 */
org.apache.flex.events.ProgressEvent.prototype.total;


/**
 * @export
 * @const
 * @type {string}
 */
org.apache.flex.events.ProgressEvent.PROGRESS = "progress";


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.events.ProgressEvent.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'ProgressEvent', qName: 'org.apache.flex.events.ProgressEvent'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.events.ProgressEvent', org.apache.flex.events.ProgressEvent);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.events.ProgressEvent.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'current': { type: 'Number'},
        'total': { type: 'Number'}
      };
    },
    accessors: function () {
      return {
      };
    },
    methods: function () {
      return {
        'ProgressEvent': { type: '', declaredBy: 'org.apache.flex.events.ProgressEvent'}
      };
    }
  };
};