/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/events/utils/MouseUtils.as
 * org.apache.flex.events.utils.MouseUtils
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.events.utils.MouseUtils');

goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 */
org.apache.flex.events.utils.MouseUtils = function() {
};


/**
 *  Returns the event target.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {org.apache.flex.events.MouseEvent} event
 * @return {Object}
 */
org.apache.flex.events.utils.MouseUtils.eventTarget = function(event) {
  return event.target;
};


/**
 *  Returns the localX value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {org.apache.flex.events.MouseEvent} event
 * @return {number}
 */
org.apache.flex.events.utils.MouseUtils.localX = function(event) {
  return event.localX;
};


/**
 *  Returns the localY value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {org.apache.flex.events.MouseEvent} event
 * @return {number}
 */
org.apache.flex.events.utils.MouseUtils.localY = function(event) {
  return event.localY;
};


/**
 *  Returns the globel X value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {org.apache.flex.events.MouseEvent} event
 * @return {number}
 */
org.apache.flex.events.utils.MouseUtils.globalX = function(event) {
  return event.screenX;
};


/**
 *  Returns the global Y value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {org.apache.flex.events.MouseEvent} event
 * @return {number}
 */
org.apache.flex.events.utils.MouseUtils.globalY = function(event) {
  return event.screenY;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.events.utils.MouseUtils.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'MouseUtils', qName: 'org.apache.flex.events.utils.MouseUtils'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.events.utils.MouseUtils', org.apache.flex.events.utils.MouseUtils);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.events.utils.MouseUtils.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
      };
    },
    methods: function () {
      return {
        'MouseUtils': { type: '', declaredBy: 'org.apache.flex.events.utils.MouseUtils'}
      };
    }
  };
};