/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/html/beads/models/PanelModel.as
 * org.apache.flex.html.beads.models.PanelModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.html.beads.models.PanelModel');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.EventDispatcher');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.core.IPanelModel');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.events.EventDispatcher}
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.core.IPanelModel}
 */
org.apache.flex.html.beads.models.PanelModel = function() {
  org.apache.flex.html.beads.models.PanelModel.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.beads.models.PanelModel, org.apache.flex.events.EventDispatcher);


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.models.PanelModel.prototype._strand;


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.models.PanelModel.prototype._controlBar;


/**
 * @private
 * @type {string}
 */
org.apache.flex.html.beads.models.PanelModel.prototype._title;


/**
 * @private
 * @type {string}
 */
org.apache.flex.html.beads.models.PanelModel.prototype._htmlTitle;


/**
 * @private
 * @type {boolean}
 */
org.apache.flex.html.beads.models.PanelModel.prototype._showCloseButton = false;


Object.defineProperties(org.apache.flex.html.beads.models.PanelModel.prototype, /** @lends {org.apache.flex.html.beads.models.PanelModel.prototype} */ {
/** @export */
strand: {
set: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function(value) {
  this._strand = value;
}},
/** @export */
controlBar: {
get: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function() {
  return this._controlBar;
},
set: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function(value) {
  this._controlBar = value;
}},
/** @export */
title: {
get: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function() {
  return this._title;
},
set: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function(value) {
  if (value != this._title) {
    this._title = value;
    this.dispatchEvent(new org.apache.flex.events.Event('titleChange'));
  }
}},
/** @export */
htmlTitle: {
get: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function() {
  return this._htmlTitle;
},
set: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function(value) {
  if (value != this._htmlTitle) {
    this._htmlTitle = value;
    this.dispatchEvent(new org.apache.flex.events.Event('htmlTitleChange'));
  }
}},
/** @export */
showCloseButton: {
get: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function() {
  return this._showCloseButton;
},
set: /** @this {org.apache.flex.html.beads.models.PanelModel} */ function(value) {
  if (value != this._showCloseButton) {
    this._showCloseButton = value;
    this.dispatchEvent(new org.apache.flex.events.Event('showCloseButtonChange'));
  }
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.models.PanelModel.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'PanelModel', qName: 'org.apache.flex.html.beads.models.PanelModel'}], interfaces: [org.apache.flex.core.IBead, org.apache.flex.core.IPanelModel] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.html.beads.models.PanelModel', org.apache.flex.html.beads.models.PanelModel);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.html.beads.models.PanelModel.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'strand': { type: 'IStrand', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'},
        'controlBar': { type: 'Array', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'},
        'title': { type: 'String', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'},
        'htmlTitle': { type: 'String', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'},
        'showCloseButton': { type: 'Boolean', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'}
      };
    },
    methods: function () {
      return {
        'PanelModel': { type: '', declaredBy: 'org.apache.flex.html.beads.models.PanelModel'}
      };
    }
  };
};