/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/optimized/SVGBoxItemRenderer.as
 * org.apache.flex.charts.optimized.SVGBoxItemRenderer
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.optimized.SVGBoxItemRenderer');

goog.require('org.apache.flex.html.supportClasses.GraphicsItemRenderer');
goog.require('org.apache.flex.charts.core.IChartItemRenderer');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.html.supportClasses.GraphicsItemRenderer}
 * @implements {org.apache.flex.charts.core.IChartItemRenderer}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer = function() {
  org.apache.flex.charts.optimized.SVGBoxItemRenderer.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.optimized.SVGBoxItemRenderer, org.apache.flex.html.supportClasses.GraphicsItemRenderer);


/**
 * @private
 * @type {org.apache.flex.charts.core.IChartSeries}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype._series;


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype._yField = "y";


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype._xField = "x";


/**
 *  @asprivate
 * @protected
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype.drawBar = function() {
  if ((this.width > 0) && (this.height > 0)) {
    this.drawRect(0, 0, this.width, this.height);
  }
};


Object.defineProperties(org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype, /** @lends {org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype} */ {
/** @export */
series: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
  return this._series;
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  this._series = value;
}},
/** @export */
yField: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
  return this._yField;
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  this._yField = value;
}},
/** @export */
xField: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
  return this._xField;
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  this._xField = value;
}},
/** @export */
data: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'data');
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'data', value);
  this.drawBar();
}},
/** @export */
width: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'width');
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'width', value);
  this.drawBar();
}},
/** @export */
height: {
get: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'height');
},
set: /** @this {org.apache.flex.charts.optimized.SVGBoxItemRenderer} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.charts.optimized.SVGBoxItemRenderer, this, 'height', value);
  this.drawBar();
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'SVGBoxItemRenderer', qName: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'}], interfaces: [org.apache.flex.charts.core.IChartItemRenderer] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.optimized.SVGBoxItemRenderer', org.apache.flex.charts.optimized.SVGBoxItemRenderer);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.optimized.SVGBoxItemRenderer.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'series': { type: 'IChartSeries', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'},
        'yField': { type: 'String', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'},
        'xField': { type: 'String', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'},
        'data': { type: 'Object', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'},
        'width': { type: 'Number', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'},
        'height': { type: 'Number', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'}
      };
    },
    methods: function () {
      return {
        'SVGBoxItemRenderer': { type: '', declaredBy: 'org.apache.flex.charts.optimized.SVGBoxItemRenderer'}
      };
    }
  };
};