/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/core/ListBase.as
 * org.apache.flex.core.ListBase
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.core.ListBase');

goog.require('org.apache.flex.core.ListBaseStrandChildren');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.core.IContentViewHost');
goog.require('org.apache.flex.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.core.UIBase}
 * @implements {org.apache.flex.core.IContentViewHost}
 */
org.apache.flex.core.ListBase = function() {
  org.apache.flex.core.ListBase.base(this, 'constructor');
  this._strandChildren = new org.apache.flex.core.ListBaseStrandChildren(this);
};
goog.inherits(org.apache.flex.core.ListBase, org.apache.flex.core.UIBase);


/**
 * @private
 * @type {org.apache.flex.core.ListBaseStrandChildren}
 */
org.apache.flex.core.ListBase.prototype._strandChildren;


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @return {number}
 */
org.apache.flex.core.ListBase.prototype.$numElements = function() {
  return org.apache.flex.core.ListBase.base(this, 'numElements');
};


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @param {Object} c
 * @param {boolean=} dispatchEvent
 */
org.apache.flex.core.ListBase.prototype.$addElement = function(c, dispatchEvent) {
  dispatchEvent = typeof dispatchEvent !== 'undefined' ? dispatchEvent : true;
  org.apache.flex.core.ListBase.base(this, 'addElement', c, dispatchEvent);
};


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @param {Object} c
 * @param {number} index
 * @param {boolean=} dispatchEvent
 */
org.apache.flex.core.ListBase.prototype.$addElementAt = function(c, index, dispatchEvent) {
  dispatchEvent = typeof dispatchEvent !== 'undefined' ? dispatchEvent : true;
  org.apache.flex.core.ListBase.base(this, 'addElementAt', c, index, dispatchEvent);
};


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @param {Object} c
 * @param {boolean=} dispatchEvent
 */
org.apache.flex.core.ListBase.prototype.$removeElement = function(c, dispatchEvent) {
  dispatchEvent = typeof dispatchEvent !== 'undefined' ? dispatchEvent : true;
  org.apache.flex.core.ListBase.base(this, 'removeElement', c, dispatchEvent);
};


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @param {Object} c
 * @return {number}
 */
org.apache.flex.core.ListBase.prototype.$getElementIndex = function(c) {
  return org.apache.flex.core.ListBase.base(this, 'getElementIndex', c);
};


/**
 * @asprivate
 * @suppress {undefinedNames}
 * Support strandChildren.
 * @export
 * @param {number} index
 * @return {Object}
 */
org.apache.flex.core.ListBase.prototype.$getElementAt = function(index) {
  return org.apache.flex.core.ListBase.base(this, 'getElementAt', index);
};


Object.defineProperties(org.apache.flex.core.ListBase.prototype, /** @lends {org.apache.flex.core.ListBase.prototype} */ {
/** @export */
strandChildren: {
get: /** @this {org.apache.flex.core.ListBase} */ function() {
  return this._strandChildren;
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.core.ListBase.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'ListBase', qName: 'org.apache.flex.core.ListBase'}], interfaces: [org.apache.flex.core.IContentViewHost] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.core.ListBase', org.apache.flex.core.ListBase);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.core.ListBase.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'strandChildren': { type: 'IParent', declaredBy: 'org.apache.flex.core.ListBase'}
      };
    },
    methods: function () {
      return {
        'ListBase': { type: '', declaredBy: 'org.apache.flex.core.ListBase'},
        '$numElements': { type: 'int', declaredBy: 'org.apache.flex.core.ListBase'},
        '$addElement': { type: 'void', declaredBy: 'org.apache.flex.core.ListBase'},
        '$addElementAt': { type: 'void', declaredBy: 'org.apache.flex.core.ListBase'},
        '$removeElement': { type: 'void', declaredBy: 'org.apache.flex.core.ListBase'},
        '$getElementIndex': { type: 'int', declaredBy: 'org.apache.flex.core.ListBase'},
        '$getElementAt': { type: 'Object', declaredBy: 'org.apache.flex.core.ListBase'}
      };
    }
  };
};