/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/core/MXMLDragInitiator.as
 * org.apache.flex.core.MXMLDragInitiator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.core.MXMLDragInitiator');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.EventDispatcher');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.core.IDragInitiator');
goog.require('org.apache.flex.utils.Language');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.events.EventDispatcher}
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.core.IDragInitiator}
 */
org.apache.flex.core.MXMLDragInitiator = function() {
  org.apache.flex.core.MXMLDragInitiator.base(this, 'constructor');
};
goog.inherits(org.apache.flex.core.MXMLDragInitiator, org.apache.flex.events.EventDispatcher);


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.core.MXMLDragInitiator.prototype._strand;


/**
 * @export
 * @type {Object}
 */
org.apache.flex.core.MXMLDragInitiator.prototype.dropTarget;


/**
 * @export
 * @type {string}
 */
org.apache.flex.core.MXMLDragInitiator.prototype.dropType;


/**
 *  Handles the acceptingDrop API
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {Object} dropTarget
 * @param {string} type
 */
org.apache.flex.core.MXMLDragInitiator.prototype.acceptingDrop = function(dropTarget, type) {
  this.dispatchEvent(new org.apache.flex.events.Event("acceptingDrop"));
};


/**
 *  Handles the acceptedDrop API
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @export
 * @param {Object} dropTarget
 * @param {string} type
 */
org.apache.flex.core.MXMLDragInitiator.prototype.acceptedDrop = function(dropTarget, type) {
  this.dispatchEvent(new org.apache.flex.events.Event("acceptedDrop"));
};


Object.defineProperties(org.apache.flex.core.MXMLDragInitiator.prototype, /** @lends {org.apache.flex.core.MXMLDragInitiator.prototype} */ {
/** @export */
strand: {
set: /** @this {org.apache.flex.core.MXMLDragInitiator} */ function(value) {
  this._strand = value;
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.core.MXMLDragInitiator.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'MXMLDragInitiator', qName: 'org.apache.flex.core.MXMLDragInitiator'}], interfaces: [org.apache.flex.core.IBead, org.apache.flex.core.IDragInitiator] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.core.MXMLDragInitiator', org.apache.flex.core.MXMLDragInitiator);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.core.MXMLDragInitiator.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'dropTarget': { type: 'Object'},
        'dropType': { type: 'String'}
      };
    },
    accessors: function () {
      return {
        'strand': { type: 'IStrand', declaredBy: 'org.apache.flex.core.MXMLDragInitiator'}
      };
    },
    methods: function () {
      return {
        'MXMLDragInitiator': { type: '', declaredBy: 'org.apache.flex.core.MXMLDragInitiator'},
        'acceptingDrop': { type: 'void', declaredBy: 'org.apache.flex.core.MXMLDragInitiator'},
        'acceptedDrop': { type: 'void', declaredBy: 'org.apache.flex.core.MXMLDragInitiator'}
      };
    },
    metadata: function () { return [ ]; }
  };
};