/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/core/TransformCompoundModel.as
 * org.apache.flex.core.TransformCompoundModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.core.TransformCompoundModel');

goog.require('org.apache.flex.core.TransformModel');
goog.require('org.apache.flex.core.ITransformModel');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.core.TransformModel}
 */
org.apache.flex.core.TransformCompoundModel = function() {
  org.apache.flex.core.TransformCompoundModel.base(this, 'constructor');
};
goog.inherits(org.apache.flex.core.TransformCompoundModel, org.apache.flex.core.TransformModel);


Object.defineProperties(org.apache.flex.core.TransformCompoundModel.prototype, /** @lends {org.apache.flex.core.TransformCompoundModel.prototype} */ {
/** @export */
transformModels: {
set: /** @this {org.apache.flex.core.TransformCompoundModel} */ function(value) {
  if (value && value.length > 0) {
    var /** @type {number} */ length = value.length;
    var /** @type {org.apache.flex.geom.Matrix} */ product = org.apache.flex.utils.Language.as(value[0], org.apache.flex.core.ITransformModel).matrix.clone();
    for (var /** @type {number} */ i = 1; i < length; i++) {
      var /** @type {org.apache.flex.geom.Matrix} */ current = org.apache.flex.utils.Language.as(value[i], org.apache.flex.core.ITransformModel).matrix;
      product.concat(current);
    }
    this.matrix = product;
  } else {
    this.matrix = null;
  }
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.core.TransformCompoundModel.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'TransformCompoundModel', qName: 'org.apache.flex.core.TransformCompoundModel'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.core.TransformCompoundModel', org.apache.flex.core.TransformCompoundModel);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.core.TransformCompoundModel.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'transformModels': { type: 'Array', declaredBy: 'org.apache.flex.core.TransformCompoundModel'}
      };
    },
    methods: function () {
      return {
      };
    },
    metadata: function () { return [ ]; }
  };
};