/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/createjs/core/CreateJSBase.as
 * org.apache.flex.createjs.core.CreateJSBase
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.createjs.core.CreateJSBase');

goog.require('org.apache.flex.createjs.core.UIBase');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.createjs.core.UIBase}
 */
org.apache.flex.createjs.core.CreateJSBase = function() {
  org.apache.flex.createjs.core.CreateJSBase.base(this, 'constructor');
};
goog.inherits(org.apache.flex.createjs.core.CreateJSBase, org.apache.flex.createjs.core.UIBase);


/**
 * @private
 * @type {org.apache.flex.graphics.IStroke}
 */
org.apache.flex.createjs.core.CreateJSBase.prototype._stroke;


/**
 * @private
 * @type {org.apache.flex.graphics.IFill}
 */
org.apache.flex.createjs.core.CreateJSBase.prototype._fill;


/**
 * @private
 * @type {org.apache.flex.graphics.IFill}
 */
org.apache.flex.createjs.core.CreateJSBase.prototype._textColor;


/**
 * The redrawShape function is called whenever visual changes are made
 * to a component. This includes its size, position, and color. Each
 * subclass provides this function.
 * @asprivate
 * @protected
 */
org.apache.flex.createjs.core.CreateJSBase.prototype.redrawShape = function() {
};


Object.defineProperties(org.apache.flex.createjs.core.CreateJSBase.prototype, /** @lends {org.apache.flex.createjs.core.CreateJSBase.prototype} */ {
/** @export */
stroke: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
  return this._stroke;
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  this._stroke = value;
  this.redrawShape();
}},
/** @export */
fill: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
  return this._fill;
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  this._fill = value;
  this.redrawShape();
}},
/** @export */
textColor: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
  return this._textColor;
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  this._textColor = value;
  this.redrawShape();
}},
/** @export */
x: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.createjs.core.CreateJSBase, this, 'x');
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.createjs.core.CreateJSBase, this, 'x', value);
  this.redrawShape();
}},
/** @export */
y: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.createjs.core.CreateJSBase, this, 'y');
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.createjs.core.CreateJSBase, this, 'y', value);
  this.redrawShape();
}},
/** @export */
width: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.createjs.core.CreateJSBase, this, 'width');
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.createjs.core.CreateJSBase, this, 'width', value);
  this.redrawShape();
}},
/** @export */
height: {
get: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function() {
return org.apache.flex.utils.Language.superGetter(org.apache.flex.createjs.core.CreateJSBase, this, 'height');
},
set: /** @this {org.apache.flex.createjs.core.CreateJSBase} */ function(value) {
  org.apache.flex.utils.Language.superSetter(org.apache.flex.createjs.core.CreateJSBase, this, 'height', value);
  this.redrawShape();
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.createjs.core.CreateJSBase.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'CreateJSBase', qName: 'org.apache.flex.createjs.core.CreateJSBase'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.createjs.core.CreateJSBase', org.apache.flex.createjs.core.CreateJSBase);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.createjs.core.CreateJSBase.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'stroke': { type: 'IStroke', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'fill': { type: 'IFill', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'textColor': { type: 'IFill', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'x': { type: 'Number', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'y': { type: 'Number', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'width': { type: 'Number', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'},
        'height': { type: 'Number', declaredBy: 'org.apache.flex.createjs.core.CreateJSBase'}
      };
    },
    methods: function () {
      return {
      };
    }
  };
};