/**
 * * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/html/NumericStepper.as
 * org.apache.flex.html.NumericStepper
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.html.NumericStepper');

goog.require('goog.events');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.html.Spinner');
goog.require('org.apache.flex.html.TextInput');
goog.require('org.apache.flex.core.IRangeModel');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.core.UIBase}
 */
org.apache.flex.html.NumericStepper = function() {
  org.apache.flex.html.NumericStepper.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.NumericStepper, org.apache.flex.core.UIBase);


/**
 * @private
 * @type {org.apache.flex.html.TextInput}
 */
org.apache.flex.html.NumericStepper.prototype.input;


/**
 * @private
 * @type {org.apache.flex.html.Spinner}
 */
org.apache.flex.html.NumericStepper.prototype.spinner;


/**
 * @flexjsignorecoercion org.apache.flex.core.WrappedHTMLElement
 * @protected
 * @override
 */
org.apache.flex.html.NumericStepper.prototype.createElement = function() {
  this.element = document.createElement('div');
  this.positioner = this.element;
  this.positioner.style.position = 'relative';
  this.input = new org.apache.flex.html.TextInput();
  this.input.className = "NumericStepperInput";
  this.input.typeNames = "NumericStepperInput";
  this.addElement(this.input);
  this.input.positioner.style.display = 'inline-block';
  this.input.positioner.style.width = '100px';
  this.spinner = new org.apache.flex.html.Spinner();
  this.addElement(this.spinner);
  this.spinner.positioner.style.display = 'inline-block';
  goog.events.listen(this.spinner, 'valueChange', org.apache.flex.utils.Language.closure(this.spinnerChange, this, 'spinnerChange'));
  this.element.flexjs_wrapper = this;
  this.className = 'NumericStepper';
  this.input.text = String(this.spinner.value);
  return this.element;
};


/**
 * @asparam event The input event.
 * @private
 * @param {Event} event
 */
org.apache.flex.html.NumericStepper.prototype.spinnerChange = function(event) {
  var /** @type {number} */ newValue = this.spinner.value;
  this.value = newValue;
  this.input.text = String(this.spinner.value);
  this.dispatchEvent(new Event('valueChange'));
};


Object.defineProperties(org.apache.flex.html.NumericStepper.prototype, /** @lends {org.apache.flex.html.NumericStepper.prototype} */ {
/** @export */
value: {
get: /** @this {org.apache.flex.html.NumericStepper} */ function() {
  return org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).value;
},
set: /** @this {org.apache.flex.html.NumericStepper} */ function(newValue) {
  org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).value = newValue;
}},
/** @export */
minimum: {
get: /** @this {org.apache.flex.html.NumericStepper} */ function() {
  return org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).minimum;
},
set: /** @this {org.apache.flex.html.NumericStepper} */ function(value) {
  org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).minimum = value;
}},
/** @export */
maximum: {
get: /** @this {org.apache.flex.html.NumericStepper} */ function() {
  return org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).maximum;
},
set: /** @this {org.apache.flex.html.NumericStepper} */ function(value) {
  org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).maximum = value;
}},
/** @export */
stepSize: {
get: /** @this {org.apache.flex.html.NumericStepper} */ function() {
  return org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).stepSize;
},
set: /** @this {org.apache.flex.html.NumericStepper} */ function(value) {
  org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).stepSize = value;
}},
/** @export */
snapInterval: {
get: /** @this {org.apache.flex.html.NumericStepper} */ function() {
  return org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).snapInterval;
},
set: /** @this {org.apache.flex.html.NumericStepper} */ function(value) {
  org.apache.flex.utils.Language.as(this.model, org.apache.flex.core.IRangeModel, true).snapInterval = value;
}}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.NumericStepper.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'NumericStepper', qName: 'org.apache.flex.html.NumericStepper'}] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.html.NumericStepper', org.apache.flex.html.NumericStepper);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.html.NumericStepper.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
      };
    },
    accessors: function () {
      return {
        'value': { type: 'Number', declaredBy: 'org.apache.flex.html.NumericStepper', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'valueChange'}]}]; }},
        'minimum': { type: 'Number', declaredBy: 'org.apache.flex.html.NumericStepper'},
        'maximum': { type: 'Number', declaredBy: 'org.apache.flex.html.NumericStepper'},
        'stepSize': { type: 'Number', declaredBy: 'org.apache.flex.html.NumericStepper'},
        'snapInterval': { type: 'Number', declaredBy: 'org.apache.flex.html.NumericStepper'}
      };
    },
    methods: function () {
      return {
        'NumericStepper': { type: '', declaredBy: 'org.apache.flex.html.NumericStepper'}
      };
    },
    metadata: function () { return [ ]; }
  };
};